- Qt 6.8
- Qt 3D
- C++ Classes
- Qt3DRender (Deprecated)
- QLayerFilter
- Qt 6.8.2 Reference Documentation

# QLayerFilter Class

class Qt3DRender::QLayerFilter

Controls layers drawn in a frame graph branch. More...

Header: | `#include <QLayerFilter>`
CMake: | `find_package(Qt6 REQUIRED COMPONENTS 3drender)` `target_link_libraries(mytarget PRIVATE Qt6::3drender)`
qmake: | `QT += 3drender`
In QML: | LayerFilter
Inherits: | Qt3DRender::QFrameGraphNode
Status: | Deprecated

- List of all members, including inherited members

## Public Types

enum | FilterMode { AcceptAnyMatchingLayers, AcceptAllMatchingLayers, DiscardAnyMatchingLayers, DiscardAllMatchingLayers }

## Properties

- filterMode : FilterMode

## Public Functions

| QLayerFilter(Qt3DCore::QNode *parent = nullptr)
void | addLayer(Qt3DRender::QLayer *layer)
Qt3DRender::QLayerFilter::FilterMode | filterMode() const
QList<Qt3DRender::QLayer *> | layers() const
void | removeLayer(Qt3DRender::QLayer *layer)
void | setFilterMode(Qt3DRender::QLayerFilter::FilterMode filterMode)

## Signals

void | filterModeChanged(Qt3DRender::QLayerFilter::FilterMode filterMode)

## Detailed Description

A Qt3DRender::QLayerFilter can be used to instruct the renderer as to which layer(s) to draw in that branch of the frame graph. QLayerFilter selects which entities to draw based on the QLayer instance(s) added to the QLayerFilter and as components to Qt3DCore::QEntity.

QLayerFilter can be configured to select or discard entities with a specific QLayer depending on the filterMode property. By default, entities referencing one of the QLayer objects that are also being referenced by the QLayerFilter are selected (AcceptAnyMatchingLayers).

Within the FrameGraph tree, multiple QLayerFilter nodes can be nested within a branch going from root to a leaf. In that case the filtering will first operate on all entities of the scene using the filtering method specified by the first declared QLayerFilter. Then the filtered subset of entities will be filtered again based on the filtering method set on the second QLayerFilter declared. This is then repeated until all QLayerFilter nodes of the branch have been consumed.

## Member Type Documentation

### enum QLayerFilter::FilterMode

Specifies the rules for selecting entities to draw.

Constant | Value | Description
--- | --- | ---
`Qt3DRender::QLayerFilter::AcceptAnyMatchingLayers` | `0` | Accept entities that reference one or more QLayer objects added to this QLayerFilter. This is the default
`Qt3DRender::QLayerFilter::AcceptAllMatchingLayers` | `1` | Accept entities that reference all the QLayer objects added to this QLayerFilter
`Qt3DRender::QLayerFilter::DiscardAnyMatchingLayers` | `2` | Discard entities that reference one or more QLayer objects added to this QLayerFilter
`Qt3DRender::QLayerFilter::DiscardAllMatchingLayers` | `3` | Discard entities that reference all QLayer objects added to this QLayerFilter

## Property Documentation

### filterMode : FilterMode

Holds the filter mode specifying the entities to select for drawing.

The default value is AcceptMatchingLayers.

Access functions:

Qt3DRender::QLayerFilter::FilterMode | filterMode() const
void | setFilterMode(Qt3DRender::QLayerFilter::FilterMode filterMode)

Notifier signal:

void | filterModeChanged(Qt3DRender::QLayerFilter::FilterMode filterMode)

## Member Function Documentation

### `[explicit]` QLayerFilter::QLayerFilter(Qt3DCore::QNode *parent = nullptr)

The constructor creates an instance with the specified parent.

### void QLayerFilter::addLayer(Qt3DRender::QLayer *layer)

Add layer to the current list of layers

### QList<Qt3DRender::QLayer *> QLayerFilter::layers() const

Returns the current list of layers

### void QLayerFilter::removeLayer(Qt3DRender::QLayer *layer)

Remove layer from the current list of layers